config/urls.py
from django.conf import settings
from django.conf.urls.static import static
from django.contrib import admin
from django.urls import include, path

urlpatterns = [
    path('admin/', admin.site.urls),
    path('', include('store_app.urls')),
    path('accounts/', include('accounts_app.urls')),
    path('captcha/', include('captcha.urls')),
    path('management/', include('management_app.urls')),
]
urlpatterns += static(settings.STATIC_URL, document_root=settings.STATIC_ROOT)
urlpatterns += static(settings.MEDIA_URL, document_root=settings.MEDIA_ROOT)

store_app/urls.py
from django.urls import path

from .views import AddCommentView, AddProductToCartView, CartView, ContactsPageView, \
    CreatedOrderView, DeleteProductInCartView, FeedbackView, GenerateOrderPdfView, \
    HistoryOrdersView, IncreaseCountProductsView, OrderingPaymentDeliveryView, \
    OrderingPaymentOnlineView, ProductDetailsView, ProductListView, \
    ReduceCountProductsView

urlpatterns = [
    path('', ProductListView.as_view(), name='home'),
    path(
        'product/<int:pk>/',
        ProductDetailsView.as_view(),
        name='product_details',
    ),

    # product page
    path('new_comment', AddCommentView.as_view(), name='add_new_comment'),
    path('add_product_to_basket', AddProductToCartView.as_view(), name='add_product_to_basket'),
    # cart page
    path('cart', CartView.as_view(), name='user_cart_page'),
    path(
        'delete_product_in_cart',
        DeleteProductInCartView.as_view(),
        name='delete_product_in_cart',
    ),
    path(
        'reduce_count_products',
        ReduceCountProductsView.as_view(),
        name='reduce_count_products',
    ),
    path(
        'increase_count_products',
        IncreaseCountProductsView.as_view(),
        name='increase_count_products',
    ),
    # ordering
    path(
        'ordering/payment_delivery',
        OrderingPaymentDeliveryView.as_view(),
        name='ordering_payment_delivery',
    ),
    path(
        'ordering/payment_online',
        OrderingPaymentOnlineView.as_view(),
        name='ordering_payment_online',
    ),
    path(
        'order_created/<int:encrypted_order_num>/<int:key>/',
        CreatedOrderView.as_view(),
        name='order_created',
    ),
    path(
        'history_orders',
        HistoryOrdersView.as_view(),
        name='history_orders',
    ),
    path(
        'pdf_details_order/<str:num_order>',
        GenerateOrderPdfView.as_view(),
        name='pdf_details_order',
    ),
    # footer
    path('contacts/', ContactsPageView.as_view(), name='contacts'),
    path('feedback_form', FeedbackView.as_view(), name='feedback_form'),

]

store_app/models.py
from django.contrib.auth.models import User
from django.core import validators
from django.db import models


class Category(models.Model):
    class Meta:
        db_table = 'category'
        verbose_name_plural = 'Категории'
        verbose_name = 'Категория'
        ordering = ['name']

    name = models.CharField(
        max_length=20,
        db_index=True,
        verbose_name='Название рубрики',
        validators=[validators.MinLengthValidator(3)],
    )

    def __str__(self):
        return self.name


class Product(models.Model):
    class Meta:
        db_table = 'product'
        verbose_name_plural = 'Товары'
        verbose_name = 'Товар'
        ordering = ['-sale_start_time']

    name = models.CharField(
        max_length=50,
        verbose_name='Название товара',
        validators=[validators.MinLengthValidator(5)],
    )
    description = models.TextField(
        blank=True,
        null=True,
        verbose_name='Описание',
        validators=[validators.MinLengthValidator(15)],
    )
    price = models.DecimalField(
        max_digits=9,
        decimal_places=2,
        blank=True, null=True,
        verbose_name='Цена',
        validators=[
            validators.MinValueValidator(1),
            validators.MaxValueValidator(1000000),
        ],
    )
    brand = models.CharField(
        max_length=50,
        verbose_name='Бренд',
        validators=[validators.MinLengthValidator(2)],
    )
    sale_start_time = models.DateTimeField(
        auto_now_add=True,
        db_index=True,
        verbose_name='Дата начала продажи',
    )
    avg_rating = models.DecimalField(
        max_digits=3, decimal_places=2,
        blank=True, null=True,
        verbose_name='Рейтинг товара',
        default=None,
        validators=[
            validators.MinValueValidator(1),
            validators.MaxValueValidator(5),
        ],
    )

    category = models.ForeignKey(
        to='Category',
        on_delete=models.PROTECT,
        null=True,
        verbose_name='Рубрика',
    )

    def __str__(self):
        return self.name


class Comment(models.Model):
    """Комментарий к товару"""

    class Meta:
        db_table = 'comment'
        verbose_name_plural = 'Комментарии'
        verbose_name = 'Комментарий'
        ordering = ['product']

    text = models.TextField(blank=True, null=True, verbose_name='Комментарий')
    rating = models.PositiveSmallIntegerField(
        validators=[
            validators.MinValueValidator(1),
            validators.MaxValueValidator(5),
        ],
        verbose_name='Оценка',
    )
    created_at = models.DateTimeField(
        auto_now_add=True,
        db_index=True,
        verbose_name='Дата комментирования',
    )

    product = models.ForeignKey(
        to=Product,
        on_delete=models.CASCADE,
        verbose_name='Товар',
        related_name='comments',
    )
    author = models.ForeignKey(
        to=User,
        on_delete=models.CASCADE,
        verbose_name='Пользователь',
        related_name='comments',
    )

    def __str__(self):
        return self.product.name


class ImageProduct(models.Model):
    """Изображение товара"""

    class Meta:
        db_table = 'image_product'
        verbose_name_plural = 'Изображения товаров'
        verbose_name = 'Изображение товара'
        ordering = ['product']

    image = models.ImageField(
        null=True, blank=True,
        verbose_name='Изображения товара',
        upload_to="images/store_app/products/",
        validators=[validators.validate_image_file_extension],
    )
    product = models.ForeignKey(Product, on_delete=models.CASCADE, verbose_name='Товар')

    def __str__(self):
        return self.product.name


class Cart(models.Model):
    class Meta:
        db_table = 'cart'
        verbose_name_plural = 'Корзина пользователя с товарами'
        verbose_name = 'Товар в корзине'
        ordering = ['user']

    user = models.OneToOneField(
        to=User,
        on_delete=models.CASCADE,
        verbose_name='Никнейм покупателя',
    )
    products = models.ManyToManyField(Product, verbose_name='Товары в корзине')

    def __str__(self):
        return 'Корзина пользователя с товарами ' + self.user.username


class ProductInCart(models.Model):
    """Товар в корзине"""

    class Meta:
        db_table = 'product_in_cart'
        verbose_name_plural = 'Количество определенного товара в корзине'
        ordering = ['cart']

    quantity = models.PositiveIntegerField(default=1, verbose_name='Количество данного товара')

    cart = models.ForeignKey(
        to=Cart,
        on_delete=models.CASCADE,
        verbose_name='Корзина',
        blank=True,
        null=True,
        related_name='product_in_cart',
    )

    product = models.ForeignKey(
        to=Product,
        on_delete=models.CASCADE,
        verbose_name='Название товара',
    )

    def __str__(self):
        return f'В корзине {self.cart.user.username} ' \
               f'лежит товар {self.product.name} в количестве ' \
               f'{self.quantity}'


class Warehouse(models.Model):
    """Склад товаров"""

    class Meta:
        db_table = 'warehouse'
        verbose_name_plural = 'Склад товаров'
        verbose_name = 'Ячейка для хранения одной позиции товара'
        ordering = ['product']

    quantity = models.PositiveSmallIntegerField(verbose_name='Количество товаров')

    product = models.OneToOneField(
        to=Product,
        on_delete=models.DO_NOTHING,
        verbose_name='Товар',
    )

    def __str__(self):
        return self.product.name + ' с количеством ' + str(self.quantity)


class Recipient(models.Model):
    """Получатель заказа"""

    class Meta:
        db_table = 'recipient'
        verbose_name_plural = 'Получатели заказа'
        verbose_name = 'Получатель заказа'
        ordering = ['name', 'surname']

    name = models.CharField(
        max_length=50,
        verbose_name='Имя получателя заказа',
        blank=True, null=True,
    )
    surname = models.CharField(
        max_length=50,
        verbose_name='Фамилия получателя заказа',
        blank=True, null=True,
    )
    phone = models.CharField(
        max_length=15,
        verbose_name='Номер телефона получателя заказа',
        blank=True, null=True,
    )

    def __str__(self):
        return f'{self.name} {self.surname}'


class Order(models.Model):
    """Оформленный заказ"""

    class Meta:
        db_table = 'order'
        verbose_name_plural = 'Заказы'
        verbose_name = 'Заказ'
        ordering = ['num_order', 'created_at']

    num_order = models.CharField(
        max_length=20,
        verbose_name='Номер заказа',
        blank=True, null=True,
        unique=True,
    )
    created_at = models.DateTimeField(
        auto_now=True,
        verbose_name='Дата и время создания зказа',
        db_index=True,
    )

    buyer_email = models.EmailField(verbose_name='Электронная почта покупателя')

    total_price = models.DecimalField(
        max_digits=9, decimal_places=2,
        blank=True, null=True,
        verbose_name='Итоговая цена заказа',
        validators=[
            validators.MinValueValidator(1),
            validators.MaxValueValidator(1000000),
        ],
    )
    payment_method = models.CharField(max_length=30, verbose_name='Способ оплаты')
    method_receive_order = models.CharField(
        max_length=30,
        verbose_name='Способ получения заказа',
        default='Самовывоз',
    )

    date_order = models.DateField(
        db_index=True,
        verbose_name='Дата получения заказа',
        blank=True, null=True,
    )

    recipient = models.ForeignKey(
        to=Recipient,
        on_delete=models.CASCADE,
        verbose_name='Получатель',
    )


class OrderProduct(models.Model):
    """Товар в заказе"""

    class Meta:
        db_table = 'order_product'
        verbose_name_plural = 'Товары в заказах'
        verbose_name = 'Товар в заказе'
        ordering = ['product', 'quantity']

    quantity = models.PositiveIntegerField(verbose_name='Количество данного товара')

    order = models.ForeignKey(
        to=Order,
        on_delete=models.CASCADE,
        verbose_name='Заказ',
        null=True, blank=True,
        related_name='product_in_order',
    )
    product = models.ForeignKey(
        to=Product,
        on_delete=models.CASCADE,
        verbose_name='Название товара',
        related_name='product_in_order',
    )

    def __str__(self):
        return f'Заказ №{str(Order.num_order).zfill(6)}.'


class ClientFeedback(models.Model):
    """Обращение клиентов с просьбой об обратной связи"""

    class Meta:
        db_table = 'client_feedback'
        verbose_name_plural = 'Заявки на обратную связь'
        verbose_name = 'Заявка на обратную связь'
        ordering = ['name', 'phone', 'email', 'given_feedback']

    name = models.CharField(
        max_length=50,
        verbose_name='Имя клиента',
        validators=[validators.MinLengthValidator(5)],
    )
    phone = models.CharField(
        max_length=15,
        verbose_name='Номер телефона для обратной связи',
    )
    email = models.EmailField(
        verbose_name='Электронная почта для обратной связи',
        validators=[validators.MinLengthValidator(5)],
    )

    question = models.TextField(
        verbose_name='Вопрос клиента',
        validators=[validators.MinLengthValidator(15)],
    )
    given_feedback = models.BooleanField(
        verbose_name='Дана ли обратная связь?',
        default=False,
    )

    def __str__(self):
        return f'Заявка на обратную связь №{str(self.pk).zfill(6)}'

store_app/views/add_comment.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.http import JsonResponse
from django.views import View

from store_app.models import Comment, Product


class AddCommentView(LoginRequiredMixin, View):
    """
        Добавление комментария (мнения по товару, его оценка)
    """

    def post(self, request):
        response_data = {}
        try:
            rating = request.POST.get('rating')
            text_comment = request.POST.get('text_comment')

            Comment.objects.create(
                rating=int(rating),
                text=text_comment,
                author=request.user,
                product=Product.objects.get(pk=request.POST.get('product_id')),
            )

            response_data['status'] = 'OK'
            response_data['rating'] = rating
            response_data['text_comment'] = text_comment
            response_data['user'] = f'{request.user.first_name} {request.user.last_name}'
            return JsonResponse(response_data)

        except Exception as e:
            print(e)
            response_data['status'] = 'BAD'
            return JsonResponse(response_data)

store_app/views/add_product_cart.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.contrib.auth.models import AnonymousUser
from django.http import JsonResponse
from django.views import View

from store_app.models import Cart, Product, ProductInCart, Warehouse


class AddProductToCartView(LoginRequiredMixin, View):
    """
        Добавление товара в корзину
    """

    def post(self, request):
        response_data = {}
        product = Product.objects.get(pk=request.POST.get('product_id'))

        try:
            product_in_warehouse = Warehouse.objects.get(product=product)
            """Проверка если пользователь ввел число, превышающее кол-во товара на складе,
            если превышает, то страница остается без изменений, в корзину ничего не добавляется"""
            if product_in_warehouse.quantity < int(request.POST.get('count_product')):
                response_data['status'] = 'MORE'
                return JsonResponse(response_data)

            cart = Cart.objects.filter(user=request.user).first()
            if cart:
                """Если корзина пользователя уже есть, и он добавлял ранее какой-то товар"""
                cart.products.add(product)
                try:
                    """
                    Если позиция данного товара уже в корзине и
                    пользователь еще хочет добавить несколько товаров одной позиции
                    """
                    product_in_cart = cart.product_in_cart.filter(product=product).first()
                    if not product_in_cart:
                        product_in_cart = ProductInCart.objects.create(
                            quantity=0,
                            product=product,
                            cart=cart,
                        )
                    product_in_cart.quantity += int(request.POST.get('count_product'))
                    product_in_cart.save()

                except Exception as e:
                    print(e)
                    """В существующую корзину добавляется новый товар и указывается количество"""
                    cart.product_in_cart.create(
                        product=product,
                        quantity=int(request.POST.get('count_product')),
                    )

            else:
                """Иначе создается корзина, и добавляется первый товар в корзину"""
                cart = Cart.objects.create(user=request.user)
                cart.products.add(product)
                ProductInCart.objects.create(
                    cart=cart,
                    product=product,
                    quantity=int(request.POST.get('count_product')),
                )

            """Кол-во этого товара теперь на складе уменьшается"""

            product_in_warehouse.quantity -= int(request.POST.get('count_product'))
            product_in_warehouse.save()

            response_data['status'] = 'OK'
            return JsonResponse(response_data)
        except Exception as e:
            print(e)
            print(request.user == AnonymousUser)
            response_data['status'] = 'BAD'
            return JsonResponse(response_data)

store_app/views/cart.py
from django.contrib.auth.mixins import LoginRequiredMixin
from django.shortcuts import render
from django.views import View

from store_app.models import Cart


class CartView(LoginRequiredMixin, View):
    """Класс страницы просмотра корзины пользователя"""

    def get(self, request):
        cart = Cart.objects.filter(user=request.user).first()
        if cart:
            products_in_cart = cart.product_in_cart.all()
            count_each_product = {}
            total_sum = 0

            for product_in_cart in products_in_cart:
                count_each_product[product_in_cart.product_id] = [
                    product_in_cart.quantity,
                    product_in_cart.quantity * product_in_cart.product.price,
                ]
                total_sum += product_in_cart.quantity * product_in_cart.product.price

            context = {
                'products': cart.products.all(),
                'is_empty_cart': False,
                'count_each_product': count_each_product,
                'total_sum': total_sum,
            }
        else:
            context = {'is_empty_cart': True}
        return render(
            request=request,
            template_name='user_cart_page.html',
            context=context,
        )

templates/store_app/contacts.html
{% extends 'base.html' %}
{% load static %}

{% block title %}
    Контакты
{% endblock title %}

{% block content %}
    <h2>Адрес магазина (пункт самовывоза)</h2>
    <p>г.Екатеринбург</p>
    <div id="map" style="width: 600px; height: 400px"></div>
{% endblock content %}

{% block scripts %}
    <script src="https://api-maps.yandex.ru/2.1/?lang=ru_RU" type="text/javascript"></script>
    <script type="text/javascript" src="{% static 'js/ya_map.js' %}"></script>
{% endblock scripts %}

templates/store_app/home.html
{% extends 'base.html' %}
{% load static %}

{% block title %}
    Главная
{% endblock title %}

{% block styles %}
    <link rel="stylesheet" href="{% static 'css/homepage_styles.css' %}"/>
{% endblock styles %}


{% block content %}
    <div class="container-fluid text-center">
        <div class="row content">
            <div class="col-sm-2 sidenav" id="list_rubrics">
                <h3>Выбрать рубрику:</h3>
                <select class="form-control" id="selectCategory" onchange="selectCategory()">
                    <option value="all">Все рубрики</option>
                    {% for category in categories %}
                        <option value="{{ category.id }}" id="rubric_{{ category.id }}">{{ category.name }}</option>
                    {% endfor %}
                </select>
                <hr>
                <h3>Найти товар:</h3>
                <div class="form-group input-group">
                    <input type="text" class="form-control" placeholder="Search.." name="search_text"
                           id="searchSymbols">
                    <span class="input-group-btn">
                    <button class="btn btn-default" type="submit" onclick="searchProduct()">
                        <span class="glyphicon glyphicon-search"></span>
                    </button>
                </span>
                </div>
            </div>
            <div class="col-sm-8 text-left">
                <div class="container">
                    <p class="lead">Cортировка</p>
                    <select class="form-control" id="selectSorting" onchange="selectSorting()">
                        <option value="default">По популярности</option>
                        <option value="price_asc">Дешевые сверху</option>
                        <option value="price_desc">Дорогие сверху</option>
                        <option value="top_rating">Высокий рейтинг по отзывым</option>
                        <option value="many_reviews">Много отзывов</option>
                    </select>
                    <hr>
                    {% if category %}
                        <h2>Выбранная категория: {{ category }}</h2>
                    {% endif %}
                    {% if sorting_type %}
                        <h3>Отсортировано по: {{ sorting_type }}</h3>
                    {% endif %}
                    {% if search_text %}
                        <h3><b>Поиск</b>: <i>{{ search_text }}</i></h3>
                    {% endif %}
                    <hr>
                    <div class="row">
                        {% for product in page_obj %}
                            <div class="col-sm-4">
                                <div class="panel panel-default">
                                    <div class="panel-heading">
                                        <p class="lead" align="center"><a
                                                href="{% url 'product_details' product.pk %}">{{ product.name }}</a></p>
                                    </div>
                                    <div class="panel-body" id="product_image">
                                        <div id="carousel_{{ forloop.counter }}" class="carousel slide"
                                             data-ride="carousel">
                                            <div class="carousel-inner">
                                                {% for image_product in product.imageproduct_set.all %}

                                                    {% if forloop.first %}
                                                        <div class="item active">
                                                            <img src="{{ image_product.image.url }}"
                                                                 alt="{{ product.title }}" width="240px" height="210px"
                                                                 class="img-thumbnail">
                                                        </div>
                                                    {% else %}
                                                        <div class="item">
                                                            <img src="{{ image_product.image.url }}"
                                                                 alt="{{ product.title }}" width="240px" height="210px"
                                                                 class="img-thumbnail">
                                                        </div>
                                                    {% endif %}

                                                {% endfor %}
                                            </div>
                                            <a class="left carousel-control" href="#carousel_{{ forloop.counter }}"
                                               role="button" data-slide="prev">
                                                <span class="glyphicon glyphicon-chevron-left"
                                                      aria-hidden="true"></span>
                                                <span class="sr-only">Предыдущий</span>
                                            </a>
                                            <a class="right carousel-control" href="#carousel_{{ forloop.counter }}"
                                               role="button" data-slide="next">
                                                <span class="glyphicon glyphicon-chevron-right"
                                                      aria-hidden="true"></span>
                                                <span class="sr-only">Следующий</span>
                                            </a>
                                        </div>
                                    </div>

                                    <div class="panel-footer">
                                        <p>Цена: {{ product.price }}</p>
                                        <p>Бренд: {{ product.brand }}</p>
                                        {% if product.avg_rating %}
                                            <p>Рейтинг:
                                                <abbr title="Количество отзывов: {{ product.comments.count }}">
                                                    {{ product.avg_rating }}
                                                </abbr>
                                            </p>
                                        {% else %}
                                            <p>Оценок нет</p>
                                        {% endif %}
                                        <form method="POST"
                                              action="{% url 'add_product_to_basket' %}"
                                              id="add_product_to_basket">
                                            {% csrf_token %}
                                            <button type="submit" id="add_to_cart">
                                                Положить в корзину<span
                                                    class="glyphicon glyphicon-shopping-cart"></span>
                                            </button>
                                            <input type="hidden" name="product_id_to_basket" value="{{ product.id }}"
                                                   id="product_id_to_basket">
                                            <input type="hidden" id="number" value="1" name="number">
                                        </form>
                                    </div>
                                </div>
                            </div>
                        {% endfor %}
                    </div>
                </div>
                <br>
                <div class="pagination" align="center">
                <span class="step-links">
                    <span class="current">
                        <code>Page {{ page_obj.number }} of {{ page_obj.paginator.num_pages }}</code>
                    </span>
                    <br>
                    {% if page_obj.has_previous %}
                        <button class="btn btn-success" onclick="changePageNumber(1)">
                            &laquo; first
                        </button>
                        <button class="btn btn-success" onclick="changePageNumber({{ page_obj.previous_page_number }})">
                            previous
                        </button>
                    {% endif %}
                    {% if page_obj.has_next %}
                        <button class="btn btn-success"
                                onclick="changePageNumber({{ page_obj.next_page_number }})">
                            next
                        </button>
                        <button class="btn btn-success" onclick="changePageNumber({{ page_obj.paginator.num_pages }})">
                            last &raquo;
                        </button>
                    {% endif %}
                </span>
                </div>
            </div>
            <div class="col-sm-2 sidenav">
                <div class="well">
                    <p>ADS</p>
                </div>
                <div class="well">
                    <p>ADS</p>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

{% block scripts %}
    <script type="text/javascript" src="{% static 'js/add_product_to_basket.js' %}"></script>
    <script type="text/javascript" src="{% static 'js/filtration_products.js' %}"></script>
{% endblock scripts %}

templates/store_app/order_history.html
{% extends 'base.html' %}

{% load static %}

{% block title %}
    История ваших заказов
{% endblock title %}

{% block styles %}
    <link rel="stylesheet" href="{% static 'css/order_history_page.css' %}"/>
{% endblock styles %}


{% block content %}
    <div class="container-fluid text-center">
        <div class="row content">
            <div class="col-sm-2 sidenav" id="myScrollspy">
                <h3>Номера заказов</h3>
                <ul class="nav nav-pills nav-stacked">
                    {% for order in orders %}

                        <li><a href="#info_order_{{ forloop.counter }}">№{{ order.num_order }}</a></li>

                    {% endfor %}
                </ul>

            </div>
            <div class="col-sm-8 text-left">
                <div class="container">
                    <div class="row">
                        <h1 align="center">История ваших заказов</h1>
                        {% for order in orders %}
                            <div class="well" id="info_order_{{ forloop.counter }}">
                                <h2>Заказ №{{ order.num_order }}</h2>
                                <h6>Дата: {{ order.created_at }}</h6>
                                {% for product_in_order in order.product_in_order.all %}
                                    <div class="media">
                                        <div class="media-left">
                                            <img src="{{ product_in_order.product.imageproduct_set.first.image.url }}"
                                                 alt="{{ product.title }}" width="100" height="100">
                                        </div>
                                        <div class="media-body">
                                            <h4 class="media-heading">
                                                <a href="{% url 'product_details' product_in_order.product.id %}">{{ product_in_order.product }}</a>
                                            </h4>
                                            <p>Количество: {{ product_in_order.quantity }}</p>
                                            <p>Цена (за штуку): {{ product_in_order.product.price }}</p>
                                        </div>
                                    </div>
                                    <hr>
                                {% endfor %}
                                <h4><strong>Итог заказа:</strong> {{ order.total_price }}</h4>
                                <a class="btn btn-primary"
                                   href="{% url 'pdf_details_order' order.num_order %}">
                                    Детали заказа в pdf
                                </a>
                            </div>


                        {% endfor %}
                    </div>
                </div>
                <br>
            </div>
            <div class="col-sm-2 sidenav">
                <div class="well">
                    <p>ADS</p>
                </div>
                <div class="well">
                    <p>ADS</p>
                </div>
            </div>
        </div>
    </div>
{% endblock content %}

templates/store_app/pdf_details_order.html
<html>
    <head>

    </head>
    <body>
        <h1>{{ num }}</h1>
    </body>
</html>